# [2.14.0](https://github.com/WeakAuras/WeakAuras2/tree/2.14.0) (2019-08-23)

[Full Changelog](https://github.com/WeakAuras/WeakAuras2/compare/2.13.4...2.14.0)

## Highlights

 - This is our first release for Classis WoW, read our blog post about this includes over [here](https://www.patreon.com/posts/29420595)
- Borders and Texts are now sub elements, you can add as many of them as you want to your auras
- Texts now support returning information from other triggers, for example you can use %2.s to display the stacks of the 2nd trigger, %3.s for the third and so on.
- Tons of more customization options for texts, offsets were requested very often
- So many bug fixes that I actually lost count
- Settings UI overhaul, use the pencil button to find more advanced features!
- Allow usage of multi units (nameplate, boss, arena, group) by custom and generic triggers
- Groups & Dynamic Groups no longer have a generated thumbnail, you can chose your own icons for them!
- Dynamic group's growers have a new option "Group by Frame", it can be "unit frame", "nameplates" or a custom function.
- And so much more, there will be blog posts! 

## Commits

InfusOnWoW (38):

- Treat font tooltips in a special way
- Show all text replacments in tooltip
- Don't use deprecated functions
- Fix anchor frame for regions inside a dynamic group
- Fix importing leading to fake timers being reapplied repeately
- Hide CLEU_CUSTOM event from custom triggers
- Fix combined editing in corner cases
- AuraBar: Include Icon in foreground frame level
- Optimize various calls to ScanForLoads
- Rewrite Border as a sub element (#1588)
- Add UNIT_FLAGS to vehicle events
- DynamicGroup: Anchor normal controlPoints to region again
- Add a item equipped load option
- Optimize load event handling
- Sub elements: Adjust frame levels
- Increase compability with auras that attached to nameplates via code
- BuffTrigger 2: Fix triggers not activating/deactivating in the same moment
- Fix continous anchoring if a anchoring is post poned
- Fix first frame of SubText
- Add a "Show GCD" option to Cooldown Progress (Item/Equipment Slot)
- Fix WeakAuras.ContainsPlaceholders to correctly handle %2.p
- Add a advanced spec load option
- Conditions: Active trigger check: Don't rely on state.show
- Ensure that we don't run init functions for auras that are not shown
- Fix glow size for non masque users
- Tweak new subtexts
- Fix SetJustfiyH call
- Item Count: Make %s return the count
- Fix unit change events for pets
- Generic Trigger: Fix specific unit not showing up in some cases
- Fix cooldown showing up if a icon gets reused
- Sanitize attaching texts to aurabars
- Fix Copy/Paste Dispaly to not copy display/group settings
- Ensure the fake PRD frame actually shows up in the options
- Add PLAYER_ENTERING_WORLD to a few status/conditions triggers
- Switch inputs to custom text function
- Fix Modernize code
- Rework text handling and introduce the concept of sub regions

Krucifom (4):

- fix my shit and disable "Garrote - silence" debuff for classic
- Add some rogue buff/debuff/ability for classic
- Ignore classic section when copying Spells into classic section
- disable some rogue buff/debuff for WoW classic

Lag (1):

- fix import error with escape from < and >

Stanzilla (24):

- Revert "temp fix our locale submissions"
- babelfish: generate file list instead of using hardcoded
- fix typo in  WA_ClassColorName
- Revert "fix import error with escape from < and >"
- changelog-script: double quote for safety
- support environment files in the translation script and add it to gitignore
- temp fix our locale submissions
- fix non-retail packager replacement
- fix libcustomglow repo path
- fix a typo
- rename icon pencil text
- colorize extra options string for triggers
- capitalize a few strings and call it extra options for glow as well
- fix a typo
- add 8.2 weapon enchants to templates
- change all sub(0,*) calls to sub(1,*)
- replace SetItemRef instead of HandleModifiedItemClick and SetHyperlink to prevent Interface action failed errors
- styling and use prettyPrint
- fix ESC key on profiling dialog
- friendly neighborhood semicolon purge
- Use UIPanelCloseButton here as well
- don't try to load ModelPicker frame on classic
- Revert "install realpath on travis"
- install realpath on travis

emptyrivers (19):

- default to height of 1 (#1585)
- also return empty string if user gives us a junk unit id
- also don't make WA_ClassColorName not do what it's supposed to
- label various custom codes
- robust-ify WA_ClassColor name
- move *new* glow feature indicators into subtree
- remove stale feature indicators
- allow string custom option to give a multiline edit box
- ensure that consistency checks are done on children of auras which thought they were a child
- grab installed uid after running Add()
- enhance parent-child validation
- shut down WeakAuras if it was installed on a target it was not packaged for
- Add history collection
- remove obsolete migration
- provide a more informative message when the login thread fails
- merge migrations into one block
- resort any region which is changed
- improve multiselect validation
- ensure option key exists before trying to say it exists

mrbuds (52):

- set moversizer strata just above region strata
- transmission: use old method for getting bnetfriend data on 8.2 and classic
- Border subregion: set default anchor to "bar" for aurabar
- increase moversizer strata  fix issue with moversizer not clickable when region strata >= "HIGH"
- disable templates for classic
- don't show error message for unknown spells
- classic: use LibClassicCasterino for cast trigger
- classic combo points: fix division per 0 for class with no combo points
- fix load condition error on classic
- CLEU: fix ignored parameter on classic for SPELL/RANGE/DAMAGE prefix
- CLEU trigger: disable spellId field for classic #1540
- war stomp reset melee swing timer
- Cooldown Spell trigger: guard against nil error when copying aura from retail to classic (#1539)
- classic: removed "Spell Activation Overlay" trigger
- Cast trigger: only unit=player for classic for now Remove support for LibClassicCast
- classic: improve support for libClassicDurations
- fix typo in stance trigger
- default value for 2 columns widget
- fix stance trigger on retail
- fix potential issue with UnitFullName returning nil value for realm
- fix specId load condition
- add missing LibGetFrame to .pkgmeta-classic
- No Texture Tweaks
- Icon: tweak icon extra options
- Icon extra settings: show "None" if nothing changed
- AuraBar: move color settings before icon settings
- SubRegions: Add Sub Regions => Add Extra Elements
- SubText: 1. Text => Text 1
- SubText: Visible => Show Text
- glow condition: visibility => show glow
- fix glow identwidth
- fix subtext indentwidth
- Allow usage of multi units (nameplate, boss, arena, group) by custom and generic triggers  - exemple of event for a TSU: UNIT_SPELLCAST_START:nameplate
- Cast trigger: fix events for nameplates
- make profiling data accessible from 3rd party
- add pencil options for icons
- add ability to set own group icon
- improve border options layout
- add ending header line between 2 collapsible groups fix #1465 moved and renamed some icon display options
- Add anchoring to nameplates and unitframes or custom for dynamic groups - require state property unit - new dependency LibGetFrame accesible from WeakAuras.GetUnitFrame - custom function take 2 parameters: frames and activeRegions   it return a table [frame or ""][regionData] = { x, y, show }   where if frame == "" it anchor to the dynamic group region
- Use same border options for dynamic group as normal groups Cleaner default border / backdrop settings
- fix SetItemRef taint
- add some druid spells
- classic: ignore modelPicker from minimize button
- cast trigger: fix cast bar hide on random button press
- fix classic load conditions
- another attempt at fixing packager condition in embeds.xml with this change libclassicdurations & libclassiccast needs to be installed standalone with dev non-packaged build
- fix wrong packager condition for embeds.xml
- remove LibRangeCheck-2.0 and disactivate "Range Check" trigger for classic
- fix embeds.xml & .toc files packaging conditions for classic
- Cast Trigger: add meta units "group", "arena", "boss", "nameplate" (#1436)
- WoW Classic compatibility (#1347)

